"{ Package: 'stx:goodies/petitparser/compiler' }"

PPCDelegateNode subclass:#PPCPlusNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Nodes'
!

!PPCPlusNode methodsFor:'as yet unclassified'!

compileWith: compiler effect: effect id: id
		
	compiler startMethod: id.
	compiler addVariable: 'retval'.
	compiler addVariable: 'element'.
		
	compiler add: 'retval := OrderedCollection new.'.
	compiler add: 'element := '.
	compiler callOnLine: (child compileWith: compiler).
	compiler add: 'error ifTrue: [ ^ self error: ''at least one occurence expected'' ].'.
	compiler add: 'retval add: element.'.
	
	compiler add: 'element := '.
	compiler callOnLine: (child compileWith: compiler).
	compiler add: '[ error ] whileFalse: ['.
	compiler indent.
	compiler add: 'retval add: element.'.
	compiler add: 'element := '.
	compiler callOnLine: (child compileWith: compiler).
	compiler dedent.
	compiler add: '].'.
	compiler add: 'self clearError.'.
	compiler add: '^ retval asArray'.
 ^ compiler stopMethod.
!

followSets: aFollowDictionary firstSets: aFirstDictionary into: aSet suchThat: aBlock
	| first |
	super followSets: aFollowDictionary firstSets:  aFirstDictionary into: aSet suchThat: aBlock.
	
	first := aFirstDictionary at: self.
	(aFollowDictionary at: child) addAll: (first reject: [:each | each isNullable])
!

prefix
	^ #plus
! !

